<?php
  /**
  *
  * ULTIMATE Seo Urls (version 3.0.1)
  *
  * @license http://www.opensource.org/licenses/gpl-2.0.php GNU Public License
  * Copyright 2020 JMC
  */

  require('includes/application_top.php');
  require DIR_FS_CATALOG . "includes/apps/ultimate_seo_urls/includes/languages/$language/usu_installer.php";
  require DIR_FS_CATALOG . 'includes/apps/ultimate_seo_urls/includes/usu_installer.php';
  $installer = new usu_installer();

  $action = $_GET['action'] ?? '';

  if (tep_not_null($action)) {
    switch ($action) {
      case 'usu_uninstall':
      case 'usu_install':
        if (!file_exists( DIR_FS_CATALOG . "includes/apps/ultimate_seo_urls/includes/languages/" . $_SESSION['language'] . "/usu_installer.php")) {
          $language = 'english';
        } else {
          $language = $_SESSION['language'];
        }

        if ($action == 'usu_install') {
          $installer->install();
          session_write_close();
          tep_redirect(tep_href_link(basename ($PHP_SELF)));
        } elseif ($action == 'usu_uninstall'){
          $installer->uninstall();
        }
        break;
      case 'usu_install_modules':
        $output ="";
        $install= $_GET['install'];
        $class = $_GET['module'];
        $module = new $class();
          switch ($class) {
            case 'nb_languages_usu': // Navbar
            $group = 'MODULE_CONTENT_NAVBAR_INSTALLED';
            $base_from = "MODULE_NAVBAR_LANGUAGES";
            $base_to = "MODULE_NAVBAR_LANGUAGES_USU";
            break;
            case 'bm_languages_usu': // Box
            $group = 'MODULE_BOXES_INSTALLED';
            $base_from = "MODULE_BOXES_LANGUAGES";
            $base_to = "MODULE_BOXES_LANGUAGES_USU";
            break;
            case 'ht_hreflang': // hreflang
            $group = 'MODULE_HEADER_TAGS_INSTALLED';
            $base_from = "";
            $base_to = "";
            break;
            case 'ht_canonical_usu': // canonical
            $group = 'MODULE_HEADER_TAGS_INSTALLED';
            $base_from = "MODULE_HEADER_TAGS_CANONICAL";
            $base_to = "MODULE_HEADER_TAGS_CANONICAL_USU";
            break;
          }

        if ($install == 'install') {
          $module->install();
          if (defined ($base_from . '_STATUS')) {
            // Check position of the old module and apply it to the new one:
            tep_db_query("UPDATE configuration SET configuration_value = '" . constant ($base_from . '_SORT_ORDER' ) . "' WHERE configuration_key = '" . $base_to . "_SORT_ORDER'");
            // Disable stock module
            tep_db_query("UPDATE configuration SET configuration_value = 'False' WHERE configuration_key = '" . $base_from . "_STATUS'");
          }
          if (defined ($base_from . '_CONTENT_PLACEMENT')) {
            tep_db_query("UPDATE configuration SET configuration_value = '" . constant ($base_from . '_CONTENT_PLACEMENT' ) . "' WHERE configuration_key = '" . $base_to . "_CONTENT_PLACEMENT'");
          }

          if ( false === strpos(constant($group), $class . ".php" ) ) {
            tep_db_query("UPDATE configuration SET configuration_value = '" . constant ($group) . ";$class.php" . "' WHERE configuration_key = '$group'");
          } elseif (is_null(constant ($group) ) ) {
            tep_db_query("UPDATE configuration SET configuration_value = '$class.php' WHERE configuration_key = '$group'");
          }

          $output = '<span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:installModule(\'' . $class . '\', \'uninstall\')"><span class="fas fa-times-circle fa-lg text-muted ml-2"></span></a>';

        } else if ($install == 'uninstall') {
          //Uninstall module:
            $module->remove();

            $modules_installed = explode(';', constant($group));
            if (($key = array_search($class . '.php', $modules_installed))) {
              unset($modules_installed[$key]);
            }
              tep_db_query("UPDATE configuration SET configuration_value = '" . implode(';', $modules_installed) . "' WHERE configuration_key = '$group'");
              $output = '<a href="javascript:installModule(\'' .$class . '\', \'install\')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span>';
        }

        echo '<span id="content">' .  $output .'</span>';
        exit(0);

        break;

      case 'usu_reset_cache':
        tep_reset_cache_data_usu('reset');
        exit(0);

        break;
      case 'Usu_Display_Setup':
        $config_query_raw = "SELECT * FROM configuration WHERE configuration_id = '" . $_GET['module'] . "'";
        $config_query = tep_db_query($config_query_raw);
        $cfg_extra = tep_db_fetch_array($config_query);
        $cInfo = new objectInfo($cfg_extra);

        $heading = $cInfo->configuration_title;

        if ($cInfo->set_function) {
          eval('$value_field = ' . $cInfo->set_function . '"' . htmlspecialchars($cInfo->configuration_value) . '");');
        } else {
          $value_field = tep_draw_input_field('configuration_value', $cInfo->configuration_value);
        }
        $contents = '<form id="configuration_form" name="configuration_form" action="usu.php?action=usu_edit_value" method="get">';
        $contents .= '<div class="alert alert-info mb-0">' . $cInfo->configuration_description . '</div><span class="ml-2">' . $value_field . '</span>';
        $contents .= '<input type="hidden" name="module" value="' . (int)$_GET['module'] .'">';

        echo '<span id="title"><strong><i class="fas fa-cog"></i> ' . $cInfo->configuration_title . '</strong></span></form>';
        if ($cInfo->configuration_key == 'USU_CACHE_SYSTEM' ) $contents .= cache_methods_check ();
        echo '<span id="content">' .  $contents. '</div></span>';
        exit(0);

        break;

      case 'usu_toggle':
        $module = $_GET['module'];
        $value = $_GET['enabled'];

        if ($value == 'True') {
          tep_db_query("UPDATE configuration SET configuration_value = 'False' WHERE configuration_id = '" . (int)$module . "'");

          tep_reset_cache_data_usu('reset');

          $output = '<a href="javascript:toggleModule(\'' . $module . '\', \'False\')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span>';

        } else if ($value == 'False') {
          tep_db_query("UPDATE configuration SET configuration_value = 'True' WHERE configuration_id = '" . (int)$module . "'");

          $output = '<span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:toggleModule(\'' . $module . '\', \'True\')"><span class="fas fa-times-circle fa-lg text-muted ml-2">';
        }
        echo '<span id="content">' .  $output .'</span>';
        exit(0);

        break;
      case 'usu_save_value':
        $module = tep_db_input($_POST['module']);
        $configuration_value = tep_db_input($_POST['configuration_value']);

        tep_db_query("UPDATE configuration SET configuration_value = '" . $configuration_value . "' WHERE configuration_id = '" . $module . "'");

        tep_reset_cache_data_usu('reset');

        $output = $configuration_value . '<a  href="javascript:DisplaySetup(' . $module . ');" class="text-info btn-sm"><span class="fas fa-edit fa-lg"></span></a>';
        echo '<span id="content">' .  $output .'</span>';
        exit(0);
        break;
    }
  }

  if (defined ('USU_VERSION')) {

    $installer->check();
    $htaccesfile = fopen(DIR_FS_CATALOG . '.htaccess','r');

    if($htaccesfile) {
      // Verify if the file contains the rewrite rules already;
      if( false  ==  strpos(fread ($htaccesfile, filesize( DIR_FS_CATALOG . '.htaccess')), '## BEGIN USU URL rewrite rules ##')) {
        $messageStack->add_session(WARNING_USU_HTACCESS, 'warning');
      }
    }

    $stack = false;

    if (defined ('MODULE_NAVBAR_LANGUAGES_STATUS') && MODULE_NAVBAR_LANGUAGES_STATUS == 'True' )
      $stack .= '<li>' . USU_STOCK_NAVBAR_MODULE . '</li>';

    if (defined ('MODULE_BOXES_LANGUAGES_STATUS') && MODULE_BOXES_LANGUAGES_STATUS == 'True' )
      $stack .= '<li>' . USU_STOCK_BOX_MODULE . '</li>';

    if (defined ('MODULE_HEADER_TAGS_CANONICAL_STATUS') && MODULE_HEADER_TAGS_CANONICAL_STATUS == 'True' )
      $stack .= '<li>' . USU_STOCK_CANONICAL_MODULE . '</li>';

    if ($stack) {
      $stack = '<ul>' . $stack . '</ul>';
      $messageStack->add(sprintf(USU_WARNING, $stack), 'warning');
    }

    require('includes/template_top.php');

?>
  <div class="row">
    <div class="col">
      <h1 class="display-4 mb-2"><?php echo HEADING_TITLE; ?></h1>
    </div>
    <div class="col-sm-4 text-right align-self-center">
      <h1 class="display-5 mb-2"><?= TEXT_VERSION . USU_VERSION; ?></h1>
    </div>

  </div>

  <div class="row">
    <div class="col-lg">
      <h1 class="display-5 mb-2"><?= TITLE_OPTIONS ?></h1>
      <table class="table table-striped table-sm">
        <thead class="thead-dark">
          <tr>
            <th><?php echo TABLE_HEADING_CONFIG_TITLE; ?></th>
            <th class="text-right"><?php echo TABLE_HEADING_CONFIG_VALUE; ?></th>
          </tr>
        </thead>
        <tbody>
            <?php
    $config_query_raw = "SELECT * FROM configuration WHERE configuration_key LIKE 'USU%' ORDER BY `configuration_id` ASC";
    $config_query = tep_db_query($config_query_raw);
    while ($settings = tep_db_fetch_array($config_query)) {

    if ($settings['configuration_key'] == "USU_VERSION") continue;

    $output ="";

?>
          <tr>
            <td><b><?= $settings['configuration_title'] . ' </b><br>' . $settings['configuration_description']; ?></td>
            <td id="<?= $settings['configuration_id'] ?>" class="text-right text-nowrap"><?php

    if ($settings['configuration_value']=='True') {
      $output ='<span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:toggleModule(\'' . $settings['configuration_id'] . '\', \'' . $settings['configuration_value'] . '\')"><span class="fas fa-times-circle fa-lg text-muted ml-2"></a>';
    } else if ($settings['configuration_value'] =='False'){
      $output ='<a href="javascript:toggleModule(\'' . $settings['configuration_id'] . '\', \'' . $settings['configuration_value'] . '\')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span>';
    } else {
  ?>
  <?= $settings['configuration_value'] ?><a  href="javascript:DisplaySetup(<?= $settings['configuration_id'] ?>);" class="text-info btn-sm"><span class="fas fa-edit fa-lg"></span></a><?php
    }

    if ($settings['configuration_key'] == "USU_RESET_CACHE") {
      $output ='<a href="javascript:resetCache(\'' .  $settings['configuration_id'] . '\');"><span class="fas fa-sync-alt fa-lg text-info mr-2"></span></a>';
    }

    echo $output;
?></td>
          </tr>
<?php
    }
?>
          <tr>
            <td><?= TEXT_USU_RESET_SITEMAP ?></td>
            <td id="reset-sitemap" class="text-right"><a href="javascript:resetSitemap();"><span class="fas fa-sync-alt fa-lg text-info mr-2"></span></a></td>
          </tr>
        </tbody>
      </table>
    </div>
    <div class="col-lg">
      <h1 class="display-5 mb-2"><?= TITLE_MODULES ?></h1>
      <table class="table table-striped table-sm">
        <thead class="thead-dark">
          <tr>
            <th><?php echo TABLE_HEADING_MODULES_TITLE; ?></th>
            <th class="text-right"><?php echo TABLE_HEADING_MODULES_VALUE; ?></th>
          </tr>
        </thead>
      <tbody>
          <tr>
            <td><?= USU_NAVBAR_ACTIVATE ?></td>
            <td id="nb_languages_usu" class="text-right text-nowrap">
<?php
    if (!defined ('MODULE_NAVBAR_LANGUAGES_USU_STATUS')) {
?><a href="javascript:installModule('nb_languages_usu', 'install')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span></td>
<?php
    } else {
?><span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:installModule('nb_languages_usu', 'uninstall')"><span class="fas fa-times-circle fa-lg text-muted ml-2"></span></a></td>
<?php
    }
?>
          </tr>
          <tr>
            <td><?= USU_BOX_ACTIVATE ?></td>
            <td id="bm_languages_usu" class="text-right text-nowrap">
<?php
    if (!defined ('MODULE_BOXES_LANGUAGES_USU_STATUS')) {
?><a href="javascript:installModule('bm_languages_usu', 'install')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span></td>
<?php
    } else {
?><span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:installModule('bm_languages_usu', 'uninstall')"><span class="fas fa-times-circle fa-lg text-muted ml-2"></span></a></td>
<?php
    }
?>
          </tr>
          <tr>
            <td><?= USU_HREFLANG_ACTIVATE ?></td>
            <td id="ht_hreflang" class="text-right text-nowrap">
<?php
    if (!defined ('MODULE_HEADER_TAGS_HREFLANG_USU_STATUS')) {
?>
            <a href="javascript:installModule('ht_hreflang', 'install')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span></td>
<?php
    } else {
?>
            <span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:installModule('ht_hreflang', 'uninstall')"><span class="fas fa-times-circle fa-lg text-muted ml-2"></span></a></td>
<?php
      }
?>
          </tr>
          <tr>
            <td><?= USU_CANONICAL_ACTIVATE ?></td>
            <td id="ht_canonical_usu" class="text-right text-nowrap">
<?php
    if (!defined ('MODULE_HEADER_TAGS_CANONICAL_USU_STATUS')) {
?>
            <a href="javascript:installModule('ht_canonical_usu', 'install')"><span class="fas fa-check-circle fa-lg text-muted"></span></a><span class="fas fa-times-circle fa-lg text-danger ml-2"></span></td>
<?php
    } else {
?>
            <span class="fas fa-check-circle fa-lg text-success"></span><a href="javascript:installModule('ht_canonical_usu', 'uninstall')"><span class="fas fa-times-circle fa-lg text-muted ml-2"></span></a></td>
<?php
    }
?>
          </tr>
        </tbody>
      </table>
      <div class="text-center"><?= tep_draw_bootstrap_button(BUTTON_USU_UNINSTALL, 'fas fa-trash', tep_href_link('usu.php', 'action=usu_uninstall'), null, null, 'btn-danger'); ?></div>

    </div>
  </div>



  <div class="modal" tabindex="-1" role="dialog" id="usu-modal">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header" id="modal-header">
          <h4 class="modal-title"></h4>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer"><button type="button" class="btn btn-success" data-dismiss="modal" id="ModalButtonSave"><i class="fas fa-save fa-lg"></i></div>
      </div>
    </div>
  </div>

  <div class="modal fade" id="confirmation-modal" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="exampleModalLabel">Modal title</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          ...
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
          <button type="button" class="btn btn-primary">Save changes</button>
        </div>
      </div>
    </div>
  </div>

<script>

  function installModule(module, install ) {
    var params = { "action" : "usu_install_modules", "install" : install,  "module" : module};

    $.ajax({
      data:  params,
      url: 'usu.php',
      type: 'get',
      cache: false,
      beforeSend: function () {
        document.body.style.cursor = 'progress';
      },
      success:  function (response) {
        $("#" + module).html($(response).filter('#content').html());
        document.body.style.cursor = 'default';

      }
    });

  }

  function resetSitemap() {
    $.ajax({
      url: '../sitemaps/index.php',
      type: 'get',
      cache: false,
      beforeSend: function () {
        document.body.style.cursor = 'progress';
      },
      success:  function (response) {
        $("#reset-sitemap").html(  '<i class="fas fa-sync-alt fa-lg fa-spin text-warning mr-2"></i>');
        setTimeout(function (){
          $("#reset-sitemap").html(  '<a href="javascript:resetSitemap();"><span class="fas fa-sync-alt fa-lg text-info mr-2"></span></a>');
          }, 4000);
        document.body.style.cursor = 'default';
      }
    });
  }

  function resetCache(module) {
    var params = { "action" : "usu_reset_cache" };

    $.ajax({
      data:  params,
      url: 'usu.php',
      type: 'get',
      cache: false,
      beforeSend: function () {
        document.body.style.cursor = 'progress';
      },
      success:  function (response) {
        $("#" + module).html(  '<i class="fas fa-sync-alt fa-lg fa-spin text-warning mr-2"></i>');
        setTimeout(function (){
          $("#" + module).html(  '<a href="javascript:resetCache(\'' +  module + '\');"><span class="fas fa-sync-alt fa-lg text-info mr-2"></span></a>');
          }, 4000);
        document.body.style.cursor = 'default';
      }
    });
  }
  function toggleModule(module, enabled) {
    var params = { "action" : "usu_toggle", "module" : module, "enabled" : enabled };

    $.ajax({
      data:  params,
      url: 'usu.php',
      type: 'get',
      cache: false,
      beforeSend: function () {
        document.body.style.cursor = 'progress';
      },
      success:  function (response) {
        $("#" + module).html($(response).filter('#content').html());
        document.body.style.cursor = 'default';
      }
    });
  }

  $("#ModalButtonSave").click(function() {
      if ($("[name='configuration_value']").is(':radio')) {
        var value =  ($("[name='configuration_value']:checked").val());
      } else {
        var value = ($('[name="configuration_value"]').val());
      }

      var ConfigId = ($('input[name="module"').val());

      var params = {"module" : ConfigId, "configuration_value" : value};
      $.ajax({
        data:  params,
        url:   'usu.php?action=usu_save_value',
        type:  'post',
        beforeSend: function () {
          $(".modal-body").html('<div class="text-center"><i class="fas fa-spinner fa-pulse fa-3x fa-fw text-info"></i><span class="sr-only">Loading...</span></div>');
        },
        success:  function (response) {
          $("#" + ConfigId).fadeOut(function(){
            $("#" + ConfigId).html($(response).filter('#content').html()).fadeIn();
          });


        }
      });
  })


  function DisplaySetup(ConfigId) {
    var params = {"module" : ConfigId, "action" : "Usu_Display_Setup"};
    $.ajax({
      data:  params,
      url:   'usu.php',
      type:  'get',
      beforeSend: function () {
        $(".modal-body").html('<div class="text-center"><i class="fas fa-spinner fa-pulse fa-3x fa-fw text-info"></i><span class="sr-only">Loading...</span></div>');
      },
      success:  function (response) {
        $(".modal-title").html($(response).filter('#title').html());
        $(".modal-body").html($(response).filter('#content').html());
        $("#usu-modal").modal('show')
      }
    });
  }
</script>

<?php
  } else {
    require('includes/template_top.php');

?>
  <div>
    <div><h1><?php echo HEADING_TITLE; ?></h1></div>
    <div><p><?= USU_DESCRIPTION; ?></p></div>
  </div>

  <div class="row">
    <div class="col-lg text-center"><?= tep_draw_bootstrap_button(BUTTON_USU_INSTALL, 'fas fa-play-circle', tep_href_link('usu.php', 'action=usu_install'), null, null, 'btn-success'); ?></div>
  </div>
<?php
  }


  require('includes/template_bottom.php');

  require('includes/application_bottom.php');

  function cache_methods_check () {
    $result = '<div class="alert alert-info mt-2">';
    $result .= (extension_loaded('sqlite3') ? '<span class="text-success">' . TEXT_SQLITE_EXISTS  . '</span>' : '<span class="text-danger">' . TEXT_NO_SQLITE . '</span>') . '<br>';
    $result .= '</div>';
    return $result;
  }
?>
