<?php
  /**
  *
  * ULTIMATE Seo Urls (version 3.0.1)
  *
  * @license http://www.opensource.org/licenses/gpl-2.0.php GNU Public License
  * Copyright 2020 JMC
  * Portions Copyright 2008-2009 FWR Media, 2005 Bobby Easland
  * @Id uri_redirects_class.php              
  */

 /**
 * Simple uri redirects
 * @package USU_PRO
 *
 * @see includes/uri_redirects_array.php
 */
  final class Uri_Redirects {
    private static $_singleton = null;
    private static $redirects = array();
    /**
    * Class constructor
    * @access private
    */
    private function __construct() {
    } // end constructor

    /**
    * Returns a singleton instance of Uri_Redirects
    * @uses is_array()
    *
    * @access public
    * @return Uri_Redirects
    */
    public static function i() {
      if ( !self::$_singleton instanceof Uri_Redirects ) {
        
        include_once usu_Main::i()->getVar( 'includes_path' ) . 'uri_redirects_array.php';
        if ( isset( $usu_uri_redirects ) && is_array( $usu_uri_redirects ) && !empty( $usu_uri_redirects ) ) {
          self::$redirects = $usu_uri_redirects;
        }
        self::$_singleton = new self;
      }
      return self::$_singleton;
    } // end method

    /**
    * Iterates the redirects array returning the uri to redirect to if a match is found
    * @uses htmlspecialchars_decode()
    *
    * @access public
    * @return mixed - bool false / string redirection url
    */
    public function needsRedirect() {
     if ( !empty( self::$redirects ) ) {
       foreach ( self::$redirects as $target => $uri_data ) {
         if ( usu_Main::i()->getVar( 'request_uri' ) == $target ) {
           return htmlspecialchars_decode( tep_href_link( $uri_data[0], $uri_data[1] ) );
         }
       }
     }
     return false;
    }

  } // end class