<?php
  /**
  *
  * ULTIMATE Seo Urls (version 3.0.1)
  *
  * @license http://www.opensource.org/licenses/gpl-2.0.php GNU Public License
  * Copyright 2020 JMC
  */

class hook_admin_system_usu_reset_cache_function {
  var $version = '3.0.1';
  
}

  /**
  * ULTIMATE Seo Urls 
  * Resets the various cache systems
  * @param string $action
  */
  function tep_reset_cache_data_usu( $action = false ) {
    if ( $action == 'reset' ) {
      $usu_path = realpath( DIR_FS_CATALOG . '/includes/apps/ultimate_seo_urls/');
      switch( USU_CACHE_SYSTEM ) {
        case 'file':
          $path_to_cache = $usu_path . '/cache_system/file/';
          $it = new DirectoryIterator( $path_to_cache );
          while( $it->valid() ) {
            if ( !$it->isDot() && is_readable( $path_to_cache . $it->getFilename() ) && ( substr( $it->getFilename(), -6 ) == '.cache' ) ) {
              @unlink( $path_to_cache . $it->getFilename() );
            }
            $it->next();
          }
          break;
        case 'mysql':
          tep_db_query( 'TRUNCATE TABLE usu_cache' );
          break;
        case 'sqlite':
          include $usu_path . '/interfaces/cache_interface.php';
          include $usu_path . '/cache_system/sqlite.php';
          Sqlite_Cache_Module::admini()->gc();
          break;
      }
      tep_db_query( "UPDATE configuration SET configuration_value='False' WHERE configuration_key='USU_RESET_CACHE'" );
    }
  } // end function