<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2020 osCommerce

  Released under the GNU General Public License
*/

  class bm_languages_usu extends abstract_block_module {

    const CONFIG_KEY_BASE = 'MODULE_BOXES_LANGUAGES_USU_';

    public function execute() {
      global $PHP_SELF, $lng;
      if (USU_ENABLED == 'True') {
        hreflang::i()->initiate($_SESSION['navigation']->path);

        if (substr(basename($PHP_SELF), 0, 8) !== 'checkout') {
          if (!isset($lng) || !($lng instanceof language)) {
            $lng = new language();
          }
          if (count($lng->catalog_languages) > 1) {
            $tpl_data = ['group' => $this->group, 'file' => __FILE__];
            include 'includes/modules/block_template.php';
          }
        }
      }
    }

    protected function get_parameters() {
      return [
        'MODULE_BOXES_LANGUAGES_USU_STATUS' => [
          'title' => 'Enable Languages Module (USU)',
          'value' => 'True',
          'desc' => 'Do you want to add the module to your shop?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        'MODULE_BOXES_LANGUAGES_USU_CONTENT_PLACEMENT' => [
          'title' => 'Content Placement',
          'value' => 'Right Column',
          'desc' => 'Should the module be loaded in the left or right column?',
          'set_func' => "tep_cfg_select_option(['Left Column', 'Right Column'], ",
        ],
        'MODULE_BOXES_LANGUAGES_USU_SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '110',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

  }
