<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2012 osCommerce

  Released under the GNU General Public License
*/

  class ht_hreflang {
    var $code = 'ht_hreflang';
    var $group = 'header_tags';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;

    function __construct() {
      $this->title = MODULE_HEADER_TAGS_HREFLANG_USU_TITLE;
      $this->description = MODULE_HEADER_TAGS_HREFLANG_USU_DESCRIPTION;

      if ( defined('MODULE_HEADER_TAGS_HREFLANG_USU_STATUS') ) {
        $this->sort_order = MODULE_HEADER_TAGS_HREFLANG_USU_SORT_ORDER;
        $this->enabled = (MODULE_HEADER_TAGS_HREFLANG_USU_STATUS == 'True');
      }
    }

    function execute() {
      global $PHP_SELF, $oscTemplate, $lng;
      $alternate ="";
      if (USU_ENABLED == 'True') {
        hreflang::i()->initiate($_SESSION['navigation']->path);
        $pages_array = array();
        foreach (hreflang::i()->lang_array() as $lang_array) {
          $alternate .= '<link rel="alternate" hreflang="' . $lang_array['code'] . '" href="' . $lang_array['href'] . '" />' . PHP_EOL;
          if ($lang_array['code'] == DEFAULT_LANGUAGE) {
            $alternate .= '<link rel="alternate" hreflang="x-default" href="' . $lang_array['href']  . '" />' . PHP_EOL;
          }
        }
        $oscTemplate->addBlock($alternate, $this->group);
      }
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_HEADER_TAGS_HREFLANG_USU_STATUS');
    }

    function install() {
      tep_db_query("INSERT INTO configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('Enable Robot hreflang Module', 'MODULE_HEADER_TAGS_HREFLANG_USU_STATUS', 'True', 'Do you want to enable the hreflang module?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("INSERT INTO configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) VALUES ('Sort Order', 'MODULE_HEADER_TAGS_HREFLANG_USU_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("DELETE FROM configuration WHERE configuration_key IN ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_HEADER_TAGS_HREFLANG_USU_STATUS', 'MODULE_HEADER_TAGS_HREFLANG_USU_SORT_ORDER');
    }

  }

?>
