<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2020 osCommerce

  Released under the GNU General Public License
*/

  class nb_languages_usu extends abstract_block_module {

    const CONFIG_KEY_BASE = 'MODULE_NAVBAR_LANGUAGES_USU_';

    public $group = 'navbar_modules_right';

    function getOutput() {
      if (!isset($lng) || (isset($lng) && !is_object($lng))) {
        $lng = new language;
      }

      if (USU_ENABLED == 'True' && count($lng->catalog_languages) > 1) {
        hreflang::i()->initiate($_SESSION['navigation']->path);

        if (substr(basename($GLOBALS['PHP_SELF']), 0, strlen('checkout')) !== 'checkout') {
          if (($GLOBALS['lng'] ?? null) instanceof language) {
            $lng =& $GLOBALS['lng'];
          } else {
            $lng = new language();
          }

          $tpl_data = ['group' => $this->group, 'file' => __FILE__];
          include 'includes/modules/block_template.php';
        }
      }
    }

    protected function get_parameters() {
      return [
        $this->config_key_base . 'STATUS' => [
          'title' => 'Enable Languages Module',
          'value' => 'True',
          'desc' => 'Do you want to add the module to your Navbar?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        $this->config_key_base . 'CONTENT_PLACEMENT' => [
          'title' => 'Content Placement',
          'value' => 'Right',
          'desc' => 'Should the module be loaded in the Left or Right or the Home area of the Navbar?',
          'set_func' => "tep_cfg_select_option(['Left', 'Right', 'Home'], ",
        ],
        $this->config_key_base . 'SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '535',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
      ];
    }

  }
